const concat        = require('gulp-concat');
const rename        = require('gulp-rename');
const uglify        = require('gulp-uglify');
const gulp          = require('gulp');
const pump          = require('pump');
const jshint        = require('gulp-jshint');
const replace       = require('gulp-replace');
const clean			= require('gulp-clean');

var paths = {
    srcJS:    'src/js/*.js',
    tmp:      'tmp',
    dist:     'dist/'
};

gulp.task('uglify', function() {
    pump(
        [
            gulp.src([
                paths.srcJS
            ]),
            concat('foca-directivas.js'),
            gulp.dest(paths.tmp),
            rename('foca-directivas.min.js'),
            uglify(),
            gulp.dest(paths.dist)
        ]
    );
});

gulp.task('pre-commit', function() {
    pump(
        [
            gulp.src(paths.srcJS),
            jshint('.jshintrc'),
            jshint.reporter('default'),
            jshint.reporter('fail')
        ]
    );

    gulp.start('uglify');
});

gulp.task('clean-post-install', function(){
    return gulp.src(['src', 'tmp', '.jshintrc','readme.md', '.gitignore', 'gulpfile.js'], {read: false})
    .pipe(clean());
});

gulp.task('watch', function() {
    return gulp.watch([paths.srcJS], ['uglify']);
});
